package com.cool.hot100.linkedlist;

import org.junit.Test;

public class Num234 {

    /**
     * DayNumber 2
     * Date 2024/8/20
     * Hard 1
     *
     * @return
     */
    public ListNode node;

    public boolean isPalindrome(ListNode head) {
//        node = head;
//        return reNodeCheck(head);
        //时间复杂度为O(n),空间复杂度为O(1)解法
        ListNode slowNode = head;
        ListNode fastNode = head;
        while (fastNode.next != null && fastNode.next.next != null) {
            fastNode = fastNode.next.next;
            slowNode = slowNode.next;
        }
        ListNode temp = head;
        ListNode reverse = reverse(slowNode.next);
        while (reverse != null) {
            if (reverse.val != temp.val) {
                return false;
            }
            temp = temp.next;
            reverse = reverse.next;

        }
        return true;
    }

    public ListNode reverse(ListNode node) {
        ListNode pre = null;
        while (node != null) {
            ListNode next = node.next;
            node.next = pre;
            pre = node;
            node = next;
        }
        return pre;
    }

    //递归反向对比
    public boolean reNodeCheck(ListNode node) {
        if (node != null) {
            if (!reNodeCheck(node.next)) {
                return false;
            }
            if (node.val != this.node.val) {
                return false;
            }
            this.node = this.node.next;
        }
        return true;
    }
    @Test
    public void test(){
//        ListNode node=new ListNode(5,null);
        ListNode node1=new ListNode(1,null);
        ListNode node2=new ListNode(2,node1);
        ListNode node3=new ListNode(2,node2);
        ListNode node4=new ListNode(1,node3);
        isPalindrome(node4);
    }

}
